#!/usr/bin/perl

  ### Include the standard library and define local variables.
  require './Security.pl';

  ### Print the header and a horizonal rule.
  &header("System Access Control", "");

  print <<END;
<FORM ACTION="do_libwrap.cgi" METHOD="POST">
<INPUT TYPE=HIDDEN NAME="access" VALUE="Allow">
<CENTER><TABLE BORDER=0 WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD ALIGN="LEFT" COLSPAN="3">
      <DIV CLASS="ttitle"><B>System Access Control</B>
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="3"><DIV CLASS="nbody">
      Below you can define which addresses you wish to allow secure shell
      access to.  If a host is not explicitly granted access they are denied
      and a connection cannot be established.

      <UL>
        <LI><B>IP Address</B> (for example, '192.168.1.10')</LI>
        <LI><B>IP Network</B> (for example, '192.168.1.')</LI>
      </UL>

      <P>To <B>add</B> an address simply type it into the text box below.
      <BR>To <B>remove</B> an address simply click on it below.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="3">&nbsp;</TD> </TR>
  <TR $cb> <TD COLSPAN="3">&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>IP Address</B></DIV></TD>
    <TD><DIV CLASS="nbody"><B>Service</B></DIV></TD>
    <TD><DIV CLASS="nbody"><B>Service</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS=tbody>
      <INPUT TYPE="TEXT" NAME="host" SIZE="15" MAXLENGTH="15">
    </TD>

    <TD><DIV CLASS=nbody>
      <SELECT NAME="service">
        <OPTION VALUE="sshd">Secure Shell</OPTION>
        <OPTION VALUE="simap">Secure IMAP</OPTION>
        <OPTION VALUE="spop3">Secure POP</OPTION>
      </SELECT>
    </TD>

    <TD WIDTH="50%"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" NAME="fcn" VALUE="Add Host">
    </TD>
  </TR>
</TABLE></CENTER></FORM>


<CENTER><TABLE BORDER=0 WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb> <TD><DIV CLASS="thead"><B>Allow Hosts</B></DIV></TD> </TR>
  <TR $cb>
    <TD><DIV CLASS="nbody">
    These are hosts that are allowed to connect to the specified service on
    your system.
    </TD>
  </TR>
  <TR $cb><TD><TABLE BORDER=0 WIDTH="100%" CELLPADDING=0 CELLSPACING=0>
END


  ### ############################ ###
  ### Print out the SSH addresses. ###
  ### ############################ ###
  print "<TR $cb><TD COLSPAN=4>&nbsp;</TD></TR>\n";

  print "<TR $cb><TD COLSPAN=4>\n";
  print "  <DIV CLASS=nbody><B>Service:  Secure Shell</B>\n";
  print "</TD></TR>\n";

  @sshd  = &GetACL('allow', 'sshd');
  for ($i = 0; $i < @sshd; $i++) {
    $host = $sshd[$i];
    if (($i % 5) == 0) { print "</TR><TR $cb>\n"; }
    print "<TD><DIV CLASS=nbody><A HREF=\"do_libwrap.cgi?fcn=delete&";
    print "host=$host&service=sshd&access=allow\">$host</A></TD>\n";
  }


  ### ############################## ###
  ### Print out the SIMAP addresses. ###
  ### ############################## ###
  print "<TR $cb><TD COLSPAN=4>&nbsp;</TD></TR>\n";
  print "<TR $cb><TD COLSPAN=4>&nbsp;</TD></TR>\n";

  print "<TR $cb><TD COLSPAN=4>\n";
  print "  <DIV CLASS=nbody><B>Service:  Secure IMAP</B>\n";
  print "</TD></TR>\n";

  @simap  = &GetACL('allow', 'simap');
  for ($i = 0; $i < @simap; $i++) {
    $host = $simap[$i];
    if (($i % 5) == 0) { print "</TR><TR $cb>\n"; }
    print "<TD><DIV CLASS=nbody><A HREF=\"do_libwrap.cgi?fcn=delete&";
    print "host=$host&service=simap&access=allow\">$host</A></TD>\n";
  }


  ### ############################## ###
  ### Print out the SPOP3 addresses. ###
  ### ############################## ###
  print "<TR $cb><TD COLSPAN=4>&nbsp;</TD></TR>\n";
  print "<TR $cb><TD COLSPAN=4>&nbsp;</TD></TR>\n";

  print "<TR $cb><TD COLSPAN=4>\n";
  print "  <DIV CLASS=nbody><B>Service:  Secure POP</B>\n";
  print "</TD></TR>\n";

  @spop3  = &GetACL('allow', 'spop3');
  for ($i = 0; $i < @spop3; $i++) {
    $host = $spop3[$i];
    if (($i % 5) == 0) { print "</TR><TR $cb>\n"; }
    print "<TD><DIV CLASS=nbody><A HREF=\"do_libwrap.cgi?fcn=delete&";
    print "host=$host&service=spop3&access=allow\">$host</A></TD>\n";
  }


print <<END2;
  </TABLE></TD></TR>
  <TR $cb><TD COLSPAN=1>&nbsp;</TD></TR>
  </TABLE></CENTER><P>
END2

  ### Close up and print the footer.
  &ryanFooter();

