#!/usr/bin/perl

  require "./gdbackup-lib.pl";
  &ReadParse();



  ### ###############################
  ### We want to create a new backup.
  ### ###############################
  if ($in{'FUNCTION'} eq "New Backup") {
    &header($in{'FUNCTION'}, "");

    print <<EOF03;
<CENTER>
<FORM ACTION="execute.cgi" METHOD="POST">
<P><TABLE BORDER="0" WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb> <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></TD> </TR>
  <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="thead"><B>Execute Saved Backup</B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      <B>Note:  Backup is saved to hard drive.</B>
      <P>The backup will start as soon as you click on the "Execute" button.  During this time do <B><U>not</U></B> click on stop or interrupt the web browser until you get the "Backup Complete" screen or you risk corrputing the backup file.  
     <P><B>Please choose a named backup from the list below.</B>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

  <TR $cb>
    <TD VALIGN="TOP"><DIV CLASS=nbody>
      <SELECT NAME="backupname">
EOF03

  @tmp = &listBackups(desc);

  foreach $t (@tmp) {
    print "        <OPTION VALUE=\"$t->{'code'}\">$t->{'name'}</OPTION>\n";
  }

print <<EOF30;
      </SELECT>
    </TD>
    <TD ALIGN="RIGHT"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" NAME="disk" VALUE="Save to Disk">
      <INPUT TYPE="SUBMIT" NAME="download" VALUE="Download Archive">
    </TD>
  </TR>
</TABLE>
</FORM>
</CENTER>


EOF30
  }

  ### ###########################
  ### We want to delete a backup.
  ### ###########################
  elsif ($in{'FUNCTION'} eq "Delete Backup") {
  &header($in{'FUNCTION'}, "");


print <<EOF10;

<FORM ACTION="delete.cgi" METHOD="POST">
<P><CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb> <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></TD> </TR>
  <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="thead"><B>Delete a Backup</B></TD>
  </TR>

  <TR $cb>
    <TD VALIGN="TOP" COLSPAN=2><DIV CLASS=nbody>Please select which backups you would like to delete by clicking the appropriate checkboxes below.</TD>
  </TR>

  <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

  <TR $cb>
    <TD COLSPAN=2>
      <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>
EOF10

  local $backup_directory = $text{'backup_directory'};

  $i = 0;
  @files = glob("$backup_directory/*");
  foreach (@files) {
    $_ =~ s/$backup_directory\///g;             ### Strip out filename
    $filename = $_;
    ($type, $date) = ($_ =~ m/([^\-]*)-([0-9\-]+)\.tar\.gz/);

    $desc = $text{$type};
    @keys = keys %text;

    foreach (@keys) {
      if ($text{$_} eq $type) {
        $i++;

        ($good, $bad) = split /\_/, $_;
        $tmp = $good . "_name";

        $desc = $text{$tmp};

        print "<TD WIDTH=50%><DIV CLASS=nbody>\n";
        print "<INPUT TYPE=\"CHECKBOX\" NAME=\"toDelete\" VALUE=";
        print "\"$filename\"> $desc ($date)</TD>\n";

        if (($i % 2) == 0) { print "</TR><TR $cb>\n"; }
      }
    }

  }


print <<EOF11;
    </TABLE></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" VALUE="Execute">
    </TD>
  </TR>

</TABLE>
</FORM>
</CENTER>

EOF11
  }


  ### #########################################
  ### We want to view the contents of a backup.
  ### #########################################
  elsif ($in{'FUNCTION'} eq "View Backup") {
  &header($in{'FUNCTION'}, "");


print <<EOF20;
<FORM ACTION="cat.cgi" METHOD="POST">
<P><CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb> <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></TD> </TR>
  <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="thead"><B>View The Files in a Backup</B></TD>
  </TR>

  <TR $cb>
    <TD VALIGN="TOP" COLSPAN=2>
      <DIV CLASS=nbody>Please choose a backup from below.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

  <TR $cb>
    <TD COLSPAN=2>
      <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>
EOF20

  local $backup_directory = $text{'backup_directory'};

  $i = 0;
  @files = glob("$backup_directory/*");
  foreach (@files) {
    $_ =~ s/$backup_directory\///g;             ### Strip out filename
    $filename = $_;
    ($type, $date) = ($_ =~ m/([^\-]*)-([0-9\-]+)\.tar\.gz/);

    $desc = $text{$type};
    @keys = keys %text;

    foreach (@keys) {
      if ($text{$_} eq $type) {
        $i++;

        ($good, $bad) = split /\_/, $_;
        $tmp = $good . "_name";

        $desc = $text{$tmp};

        print "<TD WIDTH=50%><DIV CLASS=nbody>\n";
        print "<INPUT TYPE=RADIO NAME=archive VALUE=\"";
        print "$text{'backup_directory'}/$filename\"> $desc ($date)</TD>\n";

        if (($i % 2) == 0) { print "</TR><TR $cb>\n"; }
      }
    }

  }

print <<EOF21;
      </TABLE>
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" VALUE="Execute">
    </TD>
  </TR>

</TABLE>
</FORM>
</CENTER>

EOF21
  }


  ### ##############################
  ### We want to see what's changed.
  ### ##############################
  elsif ($in{'FUNCTION'} eq "View Changed") {
  &header($in{'FUNCTION'}, "");


print <<EOF30;
<FORM ACTION="diff.cgi" METHOD="POST">
<P><CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb> <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></TD> </TR>
  <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="thead"><B>View The Files in a Backup That Have Changed</B></TD>
  </TR>

  <TR $cb>
    <TD VALIGN="TOP" COLSPAN=2>
      <DIV CLASS=nbody>Please choose a backup from below.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

  <TR $cb>
    <TD COLSPAN=2>
      <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>
EOF30

  local $backup_directory = $text{'backup_directory'};

  $i = 0;
  @dirs = glob("$backup_directory/*");
  foreach (@dirs) {
    $_ =~ s/$backup_directory\///g;             ### Strip out filename
    $filename = $_;
    ($type, $date) = ($_ =~ m/([^\-]*)-([0-9\-]+)\.tar\.gz/);

    $desc = $text{$type};
    @keys = keys %text;

    foreach (@keys) {
      if ($text{$_} eq $type) {
        $i++;

        ($good, $bad) = split /\_/, $_;
        $tmp = $good . "_name";

        $desc = $text{$tmp};

        #print "        <OPTION VALUE=\"$filename\">$desc ($date)</OPTION>\n"
        print "<TD WIDTH=50%><DIV CLASS=nbody>\n";
        print "<INPUT TYPE=RADIO NAME=archive VALUE=\"$filename\"> ";
        print "$desc ($date)</TD>\n";

        if (($i % 2) == 0) { print "</TR><TR $cb>\n"; }
      }
    }

  }


print <<EOF31;
      </TABLE>
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" VALUE="Execute">
    </TD>
  </TR>

</TABLE>
</FORM>
</CENTER>

EOF31
  }




  ### ############################
  ### We want to restore a backup.
  ### ############################
  elsif ($in{'FUNCTION'} eq "Restore Backup") {

    &header($in{'FUNCTION'}, "");
    print <<EOF40;

<CENTER>
<FORM ACTION="restore.cgi" METHOD="POST">
<TABLE BORDER="0" WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>System Backup</B></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="thead"><B>Choose a Backup to Restore</B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN=2><DIV CLASS="nbody">Please choose a backup to restore.</TD>
  </TR>

  <TR $cb> <TD COLSPAN="2">&nbsp;</TD> </TR>

  <TR $cb>
    <TD COLSPAN=2>
      <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>
EOF40

  local $backup_directory = $text{'backup_directory'};

  $i = 0;
  @files = glob("$backup_directory/*");
  foreach (@files) {
    $_ =~ s/$backup_directory\///g;             ### Strip out filename
    $filename = $_;
    ($type, $date) = ($_ =~ m/([^\-]*)-([0-9\-]+)\.tar\.gz/);

    $desc = $text{$type};
    @keys = keys %text;

    foreach (@keys) {
      if ($text{$_} eq $type) {
        $i++;

        ($good, $bad) = split /\_/, $_;
        $tmp = $good . "_name";

        $desc = $text{$tmp};

        print "<TD WIDTH=50%><DIV CLASS=nbody>\n";
        print "<INPUT TYPE=RADIO NAME=archive VALUE=\"";
        print "$text{'backup_directory'}/$filename\"> $desc ($date)</TD>\n";

        if (($i % 2) == 0) { print "</TR><TR $cb>\n"; }
      }
    }

  }

print <<EOF41;
      </TABLE>
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" VALUE="Execute">
    </TD>
  </TR>

</TABLE>
</FORM>
</CENTER>

EOF41

  }



  ### ##############################
  else {
    &redirect("");
  }

  &ryanFooter("");
