#!/usr/bin/perl

  require "./gdbackup-lib.pl";
  &ReadParse();


  ### ###############################
  ### We want to create a new backup.
  ### ###############################

  ($handle, $gargage) = split /\_/, $in{'backupname'};
  $ahandle = $handle . "_args";
  $fhandle = $handle . "_file";
  $nhandle = $handle . "_name";
  $bhandle = "backup_" . $in{'when'};


  ### Dazzle a little date stuff.
  ($day, $mon, $year) = (localtime)[3,4,5];  $mon++;  $year += 1900;
  if ($mon < 10) { $mon = "0$mon"; }
  if ($day < 10) { $day = "0$day"; }


  ### ##########################################################################
  ### We want to save the archive to disk. #####################################
  ### ##########################################################################
  if ($in{'disk'}) {
    ### Setup the command.
    $cmd  = "$text{'backup_tar'} -zPcf $text{'backup_directory'}/";
    $cmd .= "$text{$fhandle}-$year-$mon-$day.tar.gz $text{'backup_args'} ";
    $cmd .= "$text{$ahandle}";

    ### Execute the backup.
    system("$cmd > /dev/null 2>&1");

    print <<EOF;
Content-type: text/html

<HTML>
<HEAD>
  <TITLE> </TITLE>
  <SCRIPT LANGUAGE="JavaScript">
    alert("Your backup was completed successfully");
    history.go(-2);
  </SCRIPT>
</HEAD>
</HTML>
EOF
  }

  ### ##########################################################################
  ### We want to download the archive. #########################################
  ### ##########################################################################
  elsif ($in{'download'}) {

    ### '$file' is where the archive will go,
    ### '$filename' is what we want to downlod as.
    $file = &tempname();
    $filename = "$text{$fhandle}-$year-$mon-$day.tar.gz";

    ### Setup the command.
    $cmd  = "$text{'backup_tar'} -zPcf $file $text{'backup_args'} ";
    $cmd .= "$text{$ahandle}";

    ### Execute the backup.
    system("$cmd > /dev/null 2>&1");

    ### Print the HTTP header.
    print "Content-type: application/x-gzip\n";
    print "Content-Disposition: attachment; filename=\"$filename\"\n\n";

    ### Send them the archive.
    open TAR, $file;
      while (<TAR>) { print $_; }
    close TAR;

    ### Get rid of the tempfile.
    unlink $file;
  }
