#!/usr/bin/perl

  require "./gdbackup-lib.pl";
  &ReadParse();



  if ($in{'TYPE'} eq "SCHEDULE") {
    ($handle, $gargage) = split /\_/, $in{'name'};

    ### Set some keys for our $text hash.
    $ahandle = $handle . "_args";
    $fhandle = $handle . "_file";
    $nhandle = $handle . "_name";
    $bhandle = "backup_" . $in{'when'};


    $cmd  = "$text{'backup_tar'} -zPcf $text{'backup_directory'}/";
# $cmd .= "$text{$fhandle}-`date +%m-%d-%Y`.tar.gz $text{'backup_args'} $text{$ahandle}";
    $cmd .= "$text{$fhandle}-`date +%Y-%m-%d`.tar.gz $text{'backup_args'} $text{$ahandle}";
 
    $backup_str = "#!/bin/sh\n\n$cmd > /dev/null 2>&1\n";

    if ($in{'when'} eq "nightly") {
      $file = $text{$fhandle};

    &obtain_lock("/etc/cron.daily/$file");
      open CRONFILE, ">/etc/cron.daily/$file"; 
        print CRONFILE $backup_str;
      close CRONFILE;
      chmod 0700, "/etc/cron.daily/$file";
      &release_lock("/etc/cron.daily/$file");
    }
    elsif ($in{'when'} eq "weekly") {
      $file = $text{$fhandle};
  
      &obtain_lock("/etc/cron.weekly/$file");
      open CRONFILE, ">/etc/cron.weekly/$file"; 
        print CRONFILE $backup_str;
      close CRONFILE;
      chmod 0700, "/etc/cron.weekly/$file";
      &release_lock("/etc/cron.weekly/$file");
    }
    else { &PrintError("Could not write to crontab"); exit; }


    &redirect("");
}
