#!/usr/bin/perl
# delete_zone.cgi
# Delete an existing master, slave or secondary zone, and it's records file

  require './bind8-lib.pl';
  &ReadParse();

  $conf = &get_config();
  $zconf = $conf->[$in{'index'}];
  %access = &get_module_acl();
  &can_edit_zone(\%access, $zconf->{'value'}) ||
	         &error($text{'master_edelete'});
  $access{'ro'} && &error($text{'master_ero'});
  $access{'delete'} || &error($text{'master_edeletecannot'});

  $rev = $zconf->{'value'} =~ /in-addr.arpa/i;
  $type = &find("type", $zconf->{'members'})->{'value'};

  if (!$in{'confirm'}) {
    ### Ask the user if he is sure ..
    &header($text{'delete_title'}, "");

    print "<form action=delete_zone.cgi>\n";
    print "<P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>\n";
    print "<TR $tb><TD COLSPAN=2>\n";
    print "  <DIV CLASS=ttitle><B>Delete Zone</B></DIV>\n";
    print "</TD></TR>\n";
    print "<TR $tb><TD COLSPAN=2><DIV CLASS=thead><B>\n";
      print &text('delete_mesg', &arpa_to_ip($zconf->{'value'}));
    print "</B></DIV></TD></TR>\n";

    print "<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>\n";
    print "<TR $cb><TD><DIV CLASS=nbody>\n";

    if ($type eq 'master') {
      print $text{$rev ? 'delete_fwd' : 'delete_rev'}, "\n";
      print "<input type=radio name=rev value=1 checked> $text{'yes'}\n";
      print "<input type=radio name=rev value=0> $text{'no'}\n";
    }
    else { print "&nbsp;"; }

    print "</TD><TD ALIGN=RIGHT><DIV CLASS=nbody>\n";
    print "<input type=hidden name=index value=$in{'index'}>\n";
    print "<input type=submit name=confirm value='$text{'delete'}'>\n";
    print "</TD></TR>\n";

    print "</TABLE></CENTER>\n";
    print "</FORM>\n";


    &ryanFooter("");
    exit;
  }


  if (!$rev && $in{'rev'} && $type eq 'master') {
    ### Find and delete reverse records.
    local $file = &find("file", $zconf->{'members'})->{'value'};
    &lock_file($config{'chroot'}.$file);
    @recs = &read_zone_file($file, $zconf->{'value'});

    foreach $r (@recs) {
      next if ($r->{'type'} ne "A");
      ($orevconf, $orevfile, $orevrec) = &find_reverse($r->{'values'}->[0]);
      if ($orevrec && &can_edit_reverse($orevconf) &&
          $r->{'name'} eq $orevrec->{'values'}->[0] &&
          $r->{'values'}->[0] eq &arpa_to_ip($orevrec->{'name'})) {
        &lock_file($config{'chroot'}.$orevrec->{'file'});
        &delete_record($orevrec->{'file'} , $orevrec);
        &lock_file($config{'chroot'}.$orevfile);
        @orrecs = &read_zone_file($orevfile,
        $orevconf->{'value'});
        &bump_soa_record($orevfile, \@orrecs);
      }
    }
  }
  elsif ($rev && $in{'rev'} && $type eq 'master') {
    ### Find and delete forward records.
    local $file = &find("file", $zconf->{'members'})->{'value'};
    &lock_file($config{'chroot'}.$file);
    @recs = &read_zone_file($file, $zconf->{'value'});

    foreach $r (@recs) {
      next if ($r->{'type'} ne "PTR");
      ($ofwdconf, $ofwdfile, $ofwdrec) = &find_forward($r->{'values'}->[0]);
      if ($ofwdrec && &can_edit_zone($ofwdconf->{'value'}) &&
          &arpa_to_ip($r->{'name'}) eq $ofwdrec->{'values'}->[0] &&
          $r->{'values'}->[0] eq $ofwdrec->{'name'}) {
        &lock_file($config{'chroot'}.$ofwdrec->{'file'});
        &delete_record($ofwdrec->{'file'} , $ofwdrec);
        &lock_file($config{'chroot'}.$ofwdfile);
        @ofrecs = &read_zone_file($ofwdfile,
        $ofwdconf->{'value'});
        &bump_soa_record($ofwdfile, \@ofrecs);
      }
    }
  }

  ### delete the records file
  $f = &find("file", $zconf->{'members'});
  if ($f) {
    &lock_file($config{'chroot'}.&absolute_path($f->{'value'}));
    unlink($config{'chroot'}.&absolute_path($f->{'value'}));
  }

  ### remove the zone directive
  &lock_file($config{'chroot'}.$zconf->{'file'});
  $lref = &read_file_lines($config{'chroot'}.$zconf->{'file'});
  splice(@$lref, $zconf->{'line'}, $zconf->{'eline'} - $zconf->{'line'} + 1);
  &flush_file_lines();
  &unlock_all_files();


  &RestartNamed();

  &redirect("");

### can_edit_reverse(&zone)
sub can_edit_reverse {
  return $access{'reverse'} || &can_edit_zone(\%access, $_[0]->{'value'});
}
