#!/usr/bin/perl

  require './bind8-lib.pl';
  &ReadParse();

  $conf = &get_config();
  $zconf = $conf->[$in{'index'}]->{'members'};
  $dom = $conf->[$in{'index'}]->{'value'};

  %access = &get_module_acl();
  &can_edit_zone(\%access, $dom) || &error($text{'recs_ecannot'});


  &header(&text('recs_title', $text{"type_$in{'type'}"}), "");
  $arpa = &arpa_to_ip($dom);


print <<EOF01;
<P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
<TR $tb>
  <TD COLSPAN=2><DIV CLASS=ttitle><B>DNS Management</B></DIV></TD>
</TR>

<TR $tb><TD COLSPAN=2><DIV CLASS=thead><B>For zone: $arpa</B></DIV></TD></TR>

<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD WIDTH=20>&nbsp;</TD>
  <TD ALIGN=RIGHT>
    <TABLE BORDER=0 WIDTH=100%>
      <TR><TD>
EOF01


  $type = &find("type", $zconf)->{'value'};
  $file = &find("file", $zconf)->{'value'};

  &record_input($in{'index'}, $in{'type'}, $file, $dom);

print <<EOF02;
      </TD></TR>
    </TABLE>
EOF02



  @recs = &read_zone_file($file, $dom);
  @recs = grep { $_->{'type'} eq $in{'type'} } @recs;

  if (@recs) {
    @recs = &sort_records(@recs);

    foreach $v (keys %text) {
      if ($v =~ /^value_(\S+)(\d+)/) {
        $hmap{$1}->[$2-1] = $text{$v};
      }
    }

    print "  <TR $cb>\n";
    print "    <TD>&nbsp;</TD>\n";
    print "    <TD COLSPAN=2>\n";
    print "    <CENTER><TABLE WIDTH=100% CELLPADDING=0 CELLSPACING=0>\n";
    print "    <TR>\n";
    print "      <TD WIDTH=50% VALIGN=top>\n";

      $mid = int((@recs+1)/2);
      &recs_table(@recs[0 .. $mid-1]);

    print "      </TD>\n";
    print "      <TD WIDTH=50% VALIGN=top>\n";

      if ($mid < @recs) { &recs_table(@recs[$mid .. $#recs]); }

    print "      </TD>\n";
    print "    </TR>\n";
    print "    </TABLE>\n";
    print "  </TD></TR>\n\n";
  }

  print "</TD>\n";
  print "</TR>\n";
  print "</TABLE></CENTER><P>\n";

  &ryanFooter("edit_$type.cgi?index=$in{'index'}");

  ### ################## #######################################################
  ### LOCAL SUBROUTINES. #######################################################
  ### ################## #######################################################
  sub recs_table {

    print "<table border=0 CELLPADDING=0 CELLSPACING=0 WIDTH=95%>\n";

    print "<tr $tb>\n";
    print "  <td><DIV CLASS=thead><b>",
          $in{'type'} eq "PTR" ? $text{'recs_addr'} : $text{'recs_name'},
          "</b></td>\n";
    print "  <TD> &nbsp; </TD>\n";


    @hmap = @{$hmap{$in{'type'}}};
    foreach $h (@hmap) {
      print "<td><DIV CLASS=thead><b>$h</b></td>\n";
    }

    print "</tr>\n";

    for($i=0; $i<@_; $i++) {
      $r = $_[$i];
      $name = $in{'type'} eq "PTR" ? &arpa_to_ip($r->{'name'})
				       : $r->{'name'};

      if (!$access{'ro'} && $type eq 'master') {
        print "<tr $cb> <td><DIV CLASS=nbody><a href=\"edit_record.cgi?index=",
		        "$in{'index'}&type=$in{'type'}&num=$r->{'num'}\">$name",
		        "</a></td>\n";
		  }
      else {
        print "<tr $cb> <td><DIV CLASS=nbody>$name</td>\n";
      }

      print "<TD> &nbsp; </TD>\n";

      for($j=0; $j<@hmap; $j++) {
        print "<td><DIV CLASS=nbody>$r->{'values'}->[$j]</td>\n";
      }

      print "</tr>\n";
    }

    print "</table>\n";
  }

