#!/usr/bin/perl

  require './bind8-lib.pl';
  &ReadParse();

  %access = &get_module_acl();

  $conf = &get_config();
  @zones = &find("zone", $conf);

  &header($text{'find_title'}, "");

print <<EOF01;
<P><CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
<TR><TD $tb COLSPAN=2><DIV CLASS=ttitle><B>DNS Management</B></DIV></TD></TR>
<TR><TD $cb COLSPAN=2>&nbsp;</TD></TR>
<TR $cb>
  <TD WIDTH=20>&nbsp;</TD>
  <TD>
    <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>

    <TR>
      <TD $tb COLSPAN=2><DIV CLASS=thead><B>Zones matching '$in{'search'}'</TD>
    </TR>

    <TR><TD $cb COLSPAN=2>&nbsp;</TD></TR>

    <TR><TD>
EOF01

  foreach $z (@zones) {
    $v = $z->{'value'};

    next if ($v eq "." || !&can_edit_zone(\%access, $v) ||
		 $v !~ /$in{'search'}/);
    next if (($v eq "0.0.127.in-addr.arpa") || ($v eq "bind") ||
             ($v eq "localhost") || ($v eq "cache"));

    $t = &find("type", $z->{'members'})->{'value'};
    push(@zlinks, "edit_$t.cgi?index=$z->{'index'}");
    push(@ztitles, &arpa_to_ip($v));
    push(@zicons, "images/$t.gif");
    push(@ztypes, $text{"index_$t"});
    $len++;
  }

  if ($len) {
	# sort list of zones
	@zorder = sort { $ztitles[$a] cmp $ztitles[$b] } (0 .. $len-1);
	@zlinks = map { $zlinks[$_] } @zorder;
	@ztitles = map { $ztitles[$_] } @zorder;
	@zicons = map { $zicons[$_] } @zorder;
	@ztypes = map { $ztypes[$_] } @zorder;

	if ($config{'show_list'}) {
		# display as list
		$mid = int((@zlinks+1)/2);
		print "<table width=100%><tr><td width=50% valign=top>\n";
		&zones_table([ @zlinks[0 .. $mid-1] ],
			     [ @ztitles[0 .. $mid-1] ],
			     [ @ztypes[0 .. $mid-1] ]);
		print "</td><td width=50% valign=top>\n";
		if ($mid < @zlinks) {
			&zones_table([ @zlinks[$mid .. $#zlinks] ],
				     [ @ztitles[$mid .. $#ztitles] ],
				     [ @ztypes[$mid .. $#ztypes] ]);
			}
		print "</td></tr></table>\n";
		}
	else {
		# display as icons
		&icons_table(\@zlinks, \@ztitles, \@zicons);
		}
  }
  else { print "<b>$text{'find_none'}</b><p>\n"; }


print <<EOF02;
    </TD></TR>
    </TABLE>
  </TD>
</TR>
</TABLE><P>
EOF02

  &ryanFooter("", $text{'index_return'});


