#!/usr/bin/perl

  ### Startup stuff.
  require 'net-lib.pl';
  &header($text{'index_title'}, "", undef, 1, 1);

print <<MID;
<P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN=4><DIV CLASS=thead><B>Persistent Interfaces</TD>
  </TR>

  <TR $cb>
    <TD COLSPAN=4><DIV CLASS=nbody>
      Below is a listing of all the interfaces that are activated at boot.
    </TD>
  </TR>

  <TR $cb><TD COLSPAN=4>&nbsp;</TD></TR>

  <TR>
    <TD $cb>&nbsp;</TD>
    <TD $tb>&nbsp;</TD>
    <TD $tb><DIV CLASS=thead><B>$text{'ifcs_ip'}</B></TD>
    <TD $tb><DIV CLASS=thead><B>Hostname</B></TD>
  </TR>

MID

  @boot = &boot_interfaces();
  @boot = sort iface_sort @boot;

  foreach $a (@boot) {
    if ($a->{'name'} eq "lo") { next; }

    my $name = gethostbyaddr(pack("C4", split(/\./, $a->{'address'})), 2);
    if (!$name) { $name = "&lt;Not Yet Defined&gt;"; }

    print "  <TR $cb>\n";
      print "    <TD>&nbsp;</TD>\n";
      print "    <TD><DIV CLASS=nbody><B><A HREF=",
            "edit_bifc.cgi?idx=$a->{'index'}>[ Edit ]</A></B></TD>\n";
      print "    <TD><DIV CLASS=nbody>", $a->{'address'}, "</TD>\n";
      print "    <TD><DIV CLASS=nbody>$name</TD>";
    print "  </TR>\n";
  }



print <<TMP;
  <TR $cb><TD COLSPAN=4>&nbsp;</TD></TR>
  <TR $cb>
    <TD>&nbsp;</TD>
    <TD COLSPAN=3><DIV CLASS=nbody>
      <B><A HREF="edit_bifc.cgi?new=1&virtual=eth0">Add a New Interface</A></B>
    </DIV></TD>
  </TR>
  <TR $cb><TD COLSPAN=4>&nbsp;</TD></TR>

  <TR><TD COLSPAN=4>&nbsp;</TD></TR>

  <TR $tb><TD COLSPAN=4><DIV CLASS=thead><B>Default Route</TD></TR>
</TABLE></CENTER>

TMP

  print &routing_input();

print <<EOF;
  <P>&nbsp;
  <CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING=0 CELLSPACING=0>
    <TR $tb><TD COLSPAN=2>
      <DIV CLASS=ttitle><B>Network Management</DIV>
    </TD></TR>

    <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

    <TR $cb>
      <TD VALIGN=TOP><DIV CLASS=nbody><B>
        <A HREF="edit_dns.cgi">DNS Client Options</A>
      </TD>
      <TD><DIV CLASS=nbody>Define what machines you use for DNS lookups.</TD>
    </TR>

    <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

    <TR $cb>
      <TD VALIGN=TOP><DIV CLASS=nbody><B>
        <A HREF="list_hosts.cgi">Host Addresses</A>
      </TD>
      <TD><DIV CLASS=nbody>Setup static host addresses.</TD>
    </TR>

    <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

  </TABLE></CENTER><BR>
EOF

  &ryanFooter("/SystemManager/");



sub iface_sort {
  return $a->{'name'} cmp $b->{'name'} if ($a->{'name'} cmp $b->{'name'});
  return $a->{'virtual'} <=> $b->{'virtual'};
}

