#!/usr/bin/perl

  require "postfix-lib.pl";
  &ReadParse();

  &header("Mail Server Management: Domain Management", "");

  $address   = &hlink("E-Mail Address", "e-mail_address");
  $email_u   = &hlink("E-Mail Username", "e-mail_username");
  $recipient = &hlink("Recipient", "recipient");

  print <<EOF01;
<P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
<TR $tb>
  <TD COLSPAN=3><DIV CLASS=ttitle><B>Mail Server Management</B></TD>
</TR>

<TR $cb> <TD COLSPAN=3>&nbsp;</TD> </TR>

<TR $cb>
  <TD><DIV CLASS=nbody>&nbsp;</DIV>
  </TD>
  <TD COLSPAN=2 ALIGN=RIGHT><DIV CLASS=tbody>
    <FORM ACTION="delete_domain.cgi" METHOD=POST>
    <INPUT TYPE=HIDDEN NAME=domain VALUE="$in{'domain'}">
    <DIV CLASS=toolfont><INPUT TYPE=SUBMIT VALUE="Delete this Domain"></DIV>
    <P></FORM>
  </DIV></TD>
</TR>

<TR $cb> <TD COLSPAN=3>&nbsp;</TD> </TR>

  <TR $tb> <TD COLSPAN=3><DIV CLASS=thead><B>Add New E-Mail User</TD> </TR>

  <TR $cb>
    <TD COLSPAN=3><DIV CLASS=nbody>
      Below you can add a new e-mail user.

      <P><B>$email_u</B> is the username you wish to create (will 
      become user\@$in{'domain'}).

      <P><B>$recipient</B> is the person you want to recieve the message.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN=3>&nbsp;</TD> </TR>

  <TR $cb>
    <TD COLSPAN=3>
    <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>

    <TR>
      <TD WIDTH=20>&nbsp;</TD>
      <TD $tb><DIV CLASS=thead><B>E-Mail Username</TD>
      <TD COLSPAN=2 $tb><DIV CLASS=thead><B>Recipient</TD>
    </TR>

    <TR>
      <TD WIDTH=20>&nbsp;</TD>
      <TD $cb><DIV CLASS=tbody>
        <FORM ACTION=save_domain.cgi METHOD=POST>
        <INPUT TYPE=HIDDEN NAME=domain VALUE=$in{'domain'}>
        <INPUT NAME=source SIZE=10>
      </TD>
      <TD $cb><DIV CLASS=tbody>
        <INPUT NAME=dest SIZE=25>
      </TD>
      <TD ALIGN=LEFT $cb><DIV CLASS=toolfont>
        <INPUT TYPE=SUBMIT NAME="new" VALUE="Add New"></DIV>
        <P></FORM>
      </TD>
    </TR>

    </TABLE>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN=3>&nbsp;</TD> </TR>
  <TR $cb> <TD COLSPAN=3>&nbsp;</TD> </TR>


  <TR $tb>
    <TD COLSPAN=3><DIV CLASS=thead><B>Edit $in{'domain'}</B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN=3><DIV CLASS=nbody>
      Below you can edit existing aliases.

      <P><B>$address</B> is of the form user\@$in{'domain'}.

      <P><B>$recipient</B> is the person that you want to recieve the 
      message.  You can select a local user by clicking on the "..." button.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN=3>&nbsp;</TD> </TR>


  <TR $cb>
    <TD COLSPAN=3>
    <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>
    <TR>
      <TD WIDTH=20>&nbsp;</TD>
      <TD $tb><DIV CLASS=thead><B>E-Mail Address</TD>
      <TD COLSPAN=2 $tb><DIV CLASS=thead><B>Recipient</TD>
    </TR>

EOF01

  @mappings = &get_mappings($in{'domain'});

  foreach $m (@mappings) {
    if ($m->{'source'} !~ m/^\@/) {
      print "<TR $cb>\n";
      print " <TD WIDTH=20>&nbsp;</TD>\n";
      print " <TD><DIV CLASS=tbody>\n";
      print "   <FORM ACTION=save_domain.cgi METHOD=POST>\n";
      print "   <INPUT TYPE=HIDDEN NAME=index VALUE=$m->{'index'}>\n";
      print "   <INPUT TYPE=HIDDEN NAME=domain VALUE=$in{'domain'}>\n";
      print "   <INPUT NAME=source VALUE=\"$m->{'source'}\" SIZE=25>\n";
      print " </TD>\n";
      print " <TD><DIV CLASS=tbody>\n";
      print "   <INPUT NAME=dest VALUE=$m->{'dest'} SIZE=20>\n";
      print " </TD>\n";
      print " <TD NOWRAP><DIV CLASS=nbody>\n";
      print &user_chooser_button("dest", 0, $m->{'index'}+ 2);
      print "&nbsp;&nbsp;<INPUT TYPE=SUBMIT NAME=delete VALUE='Delete'>\n";
      print "&nbsp;&nbsp;<INPUT TYPE=SUBMIT NAME=save VALUE='Save'>\n";
      print "<P></FORM>\n";
      print " </TD>\n";
      print "</TR>\n";
    }
    else {
      $default_index  = $m->{'index'};
      $default_source = $m->{'source'};
      $default_dest   = $m->{'dest'};
    }
  }

print <<EOF02;

<TR $cb> <TD COLSPAN=4>&nbsp;</TD> </TR>
<TR $cb>
  <TD WIDTH=20>&nbsp;</TD>
  <TD><DIV CLASS=nbody ALIGN=RIGHT><B>
EOF02

  print &hlink("Postmaster", "postmaster");

print <<EOF03;
  </TD>
  <TD><DIV CLASS=tbody>
    <FORM ACTION=save_domain.cgi METHOD=POST>
    <INPUT TYPE=HIDDEN NAME=defaultrec VALUE=1>
    <INPUT TYPE=HIDDEN NAME=domain VALUE="$in{'domain'}">
    <INPUT TYPE=HIDDEN NAME=index VALUE="$default_index">
    <INPUT TYPE=HIDDEN NAME=source VALUE="$default_source">
    <INPUT NAME=dest VALUE="$default_dest" SIZE=25></TD>
  <TD><DIV CLASS=nbody>
EOF03
    print &user_chooser_button("dest", 0, $default_index + 2);
    print "&nbsp;&nbsp;<INPUT TYPE=SUBMIT NAME=save VALUE='Save'>\n";
print <<EOF04;
  </FORM>
  </TD>
</TR>

    </TABLE>
    </TD>
  </TR>



  <TR $cb> <TD COLSPAN=3>&nbsp;</TD> </TR>
  <TR $cb> <TD COLSPAN=3>&nbsp;</TD> </TR>

</TABLE><P>
EOF04

  ### Go back to main page.
  &ryanFooter("domains.cgi");
