#!/usr/bin/perl

  require './postfix-lib.pl';

  &header("Mail Server Management: Mail Routing", "");

  print <<EOF01;
<P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
<TR $tb>
  <TD COLSPAN=2><DIV CLASS=ttitle><B>Mail Server Management</B></TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

<TR $tb>
  <TD COLSPAN=2><DIV CLASS=thead><B>Mail Routing</B></TD>
</TR>

<TR $cb>
  <TD COLSPAN=2><DIV CLASS=nbody>
  Below you can configure domains for which you would like to route mail.

  <P><B>Domain</B> is the domain for which you would like to route mail.  An example value is "linuxsecurity.com".
  <P><B>Relay mail to...</B> is the host you would like the mail to go to.  An example value is "smtp.guardiandigital.com".
  </TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

<TR $cb>
  <TD WIDTH=20>&nbsp;</TD>
  <TD>
    <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>
    <TR $tb>
      <TD><DIV CLASS=thead><B>Domain</B></DIV></TD>
      <TD COLSPAN=2><DIV CLASS=thead><B>Relay mail to...</B></DIV></TD>
    </TR>

    <TR>
      <TD><DIV CLASS=tbody>
        <FORM ACTION=edit_relay_host.cgi METHOD=POST>
        <INPUT TYPE=HIDDEN NAME=number VALUE=$map->{'number'}>
        <INPUT NAME=name VALUE="$map->{'name'}" SIZE=20>
      </TD>
      <TD><DIV CLASS=tbody>
        <INPUT NAME=value VALUE="$map->{'value'}" SIZE=30>
      </TD>
      <TD><DIV CLASS=toolfont>
        <INPUT TYPE=SUBMIT NAME=save_new VALUE="Add New">
        <P></FORM>
      </TD>
    </TR>

    </TABLE>
  </TD>
</TR>

<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

<TR $tb><TD COLSPAN=2><DIV CLASS=thead><B>Existing Mail Routes</TD></TR>

<TR $cb>
  <TD WIDTH=20>&nbsp;</TD>
  <TD>
  <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>
  <TR $cb><TD COLSPAN=3>&nbsp;</TD></TR>

  <TR $tb>
    <TD><DIV CLASS=thead><B>Domain</B></DIV></TD>
    <TD COLSPAN=2><DIV CLASS=thead><B>Relay mail to...</B></DIV></TD>
  </TR>

EOF01


  $lref = &read_file_lines("/etc/postfix/transport");

  for ($i = 0; $i < @$lref; $i++) {

    if (@$lref[$i] =~ m/^\#\#\#\ \$\ (.*)\ \$$/) {

    ($domain, $relay) = split /\ /, $1;

    print "    <TR>\n";
    print "      <TD><DIV CLASS=tbody>\n";
    print "        <FORM ACTION=edit_relay_host.cgi METHOD=POST>\n";
    print "        <INPUT TYPE=HIDDEN NAME=number VALUE=$i>\n";
    print "        <INPUT TYPE=HIDDEN NAME=olddomain VALUE=$domain>\n";
    print "        <INPUT NAME=name VALUE=\"$domain\" SIZE=20>\n";
    print "      </TD>\n";
    print "      <TD><DIV CLASS=tbody>\n";
    print "        <INPUT NAME=value VALUE=\"$relay\" SIZE=30>\n";
    print "      </TD>\n";
    print "      <TD><DIV CLASS=toolfont>\n";
    print "        <INPUT TYPE=SUBMIT NAME=delete VALUE=Delete>\n";
    print "        <INPUT TYPE=SUBMIT NAME=save VALUE=Save>\n";
    print "        <P></FORM>\n";
    print "      </TD>\n";
    print "    </TR>\n\n";


    }

  }

  &flush_file_lines();






  ### Close off the table.
  print "    </TABLE>\n";
  print "  </TD>\n";
  print "</TR>\n";
  print "</TABLE></CENTER><P>\n";

  ### Generic footer.
  &ryanFooter("");
