#!/usr/bin/perl

  ### Include the standard library and define local variables.
  require './sshd-lib.pl';
  &ReadParse();

  ### If the path is invalid then exit.
  if ($in{'keyfile'} !~ m/\.ssh/) { exit; }

  ### Setup hostname and username.
  $hostname = &get_system_hostname();
  $username = $in{'username'};

  ### Print the headers.
  print "Content-type:  application/pkcs7-mime\n";
  print "Content-Disposition: attachment; filename=\"identity-$username-$hostname.key\"\n\n";

  ### Open key and send it to user.
  open KEY, "$in{'keyfile'}"; while (<KEY>) { print $_; } close KEY;

  ### Go home.
  exit;
