#!/usr/bin/perl

  ### Include the standard library.
  require 'sshd-lib.pl';

  ### Print the header.
  &header("Generate User Key", "");

  ### Generate help and user chooser links.
  $Username_help   = &hlink("Username", "sshd-username");
  $Username_ucb    = &user_chooser_button("Username", 0);
  $IPAddress_help  = &hlink("IP Address", "sshd-ipaddress");
  $Comment_help    = &hlink("Description", "sshd-comment");
  $Passphrase_help = &hlink("Passphrase", "sshd-passphrase");


print <<EOF01;
<FORM ACTION="ssh-keygen_user.cgi" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="KeySize" VALUE="1024">
<CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING="0" CELLSPACING="0">
  <TR $tb>
    <TD COLSPAN=2><DIV CLASS=ttitle><B>Generate User Key</TD>
  </TR>

  <TR $cb>
    <TD COLSPAN=2><DIV CLASS=nbody>
      <P>Welcome to the Secure Shell key generation area.  This page will:

      <UL>
        <LI>Generate a public/private key pair.
        <LI>Place the public key in ~user/.ssh/authorized_keys.
        <LI>Make you download the private key to your computer.
      </UL>

      <P>After clicking on "Generate Key" you will be prompted to save the 
      private key to your computer.  After you do this you will be able to ssh 
      into the machine as user 'Username', using the key and the provided 
      passphrase.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>
  <TR> <TD COLSPAN=2>&nbsp;</TD></TR>
  <TR> <TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $tb>
    <TD WIDTH="40%"><DIV CLASS="thead"><B>Keyword</B></TD>
    <TD WIDTH="60%"><DIV CLASS="thead"><B>Value</B></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$Username_help</B></A></TD>
    <TD>
      <DIV CLASS="tbody"><INPUT NAME="Username" SIZE=8 MAXLENGTH=16>
      $Username_ucb
    </TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$IPAddress_help (Optional)</B></A></TD>
    <TD><DIV CLASS="tbody"><INPUT NAME="IPAddress" SIZE=15 MAXLENGTH=15></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$Comment_help</B></A></TD>
    <TD><DIV CLASS="tbody"><INPUT TYPE="TEXT" NAME="Comment" SIZE="40"></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$Passphrase_help</B></A></TD>
    <TD><DIV CLASS="tbody"><INPUT TYPE="PASSWORD" NAME="Passphrase1" SIZE="40"></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>Passphrase (again)</B></A></TD>
    <TD><DIV CLASS="tbody"><INPUT TYPE="PASSWORD" NAME="Passphrase2" SIZE="40"></TD>
  </TR>

  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" VALUE="Generate Key">
    </TD>
  </TR>
</TABLE></CENTER></FORM>
EOF01

  ### Close up and print the footer.
  &ryanFooter("");

