#!/usr/bin/perl

  require './user-lib.pl';
  &ReadParse();

  @glist = &list_groups();
  %group = %{$glist[$in{'num'}]};
  $| = 1;

  &error_setup($text{'gdel_err'});
  %access = &get_module_acl("SystemManager");
  &can_edit_group(\%access, \%group) || &error($text{'gdel_egroup'});

  &header($text{'gdel_title'}, "");

  if ($in{'confirmed'}) {
    ### Check for repeat click
    if ($group{'group'} ne $in{'group'}) {
      print "<CENTER><TABLE BORDER=\"0\" WIDTH=\"620\">\n";
      print "<TR><TD>\n";
      print "<b>$text{'gdel_ealready'}</b>. <p>\n";
      print "</TD></TR>\n";
      print "</TABLE></CENTER>\n\n";

      &ryanFooter("");
      exit;
    }

    ### Go ahead and do it!
    ### print "<CENTER><TABLE BORDER=\"0\" WIDTH=\"620\">\n";
    ### print "<TR><TD>\n";

    ###  print "$text{'gdel_group'}<br>\n";
    ###  print "$text{'gdel_done'}<p>\n";

    $ENV{'USERADMIN_GROUP'} = $group{'group'};
    $ENV{'USERADMIN_ACTION'} = 'DELETE_GROUP';
    &making_changes();
    &delete_group(\%group);
    &made_changes();

    print <<EOF03;
<P><CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb> <TD><DIV CLASS=ttitle><B>Delete Group</B></DIV></TD> </TR>

  <TR $cb> <TD>&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody>
      <B>This group was successfully deleted.
    </DIV></TD>
  </TR>

  <TR $cb> <TD>&nbsp;</TD> </TR>
</TABLE></CENTER><P>
EOF03

    &ryanFooter("");
  }

  ### ######################################### ###
  ### Make sure they want to delete this group. ###
  ### ######################################### ###
  else {
    ### Check if this is anyone's primary group.
    foreach $u (&list_users()) {
      if ($u->{'gid'} == $group{'gid'}) {
        $USERNAME = $u->{'user'};

        print <<EOF01;
<P><CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb> <TD><DIV CLASS=ttitle><B>Delete Group</B></DIV></TD> </TR>

  <TR $cb> <TD>&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody>
      <B>This group is the primary group of user $USERNAME, so it can not be
      deleted.
    </DIV></TD>
  </TR>

  <TR $cb> <TD>&nbsp;</TD> </TR>
</TABLE></CENTER><P>
EOF01

        &ryanFooter($ENV{'HTTP_REFERER'});
        exit;
      }
    }

    ### Ask if the user is sure
    $GROUP = $group{'group'};

    print <<EOF02;
<FORM ACTION="delete_group.cgi">
<INPUT TYPE=HIDDEN NAME=num VALUE="$in{'num'}">
<INPUT TYPE=HIDDEN NAME=group VALUE="$group{'group'}">
<INPUT TYPE=HIDDEN NAME=confirmed VALUE=1>
<P><CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb> <TD COLSPAN=2><DIV CLASS=ttitle><B>Delete Group</B></DIV></TD> </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody>
      <B>Are you sure you want to delete the group '$GROUP'?
    </DIV></TD>
    <TD ALIGN=RIGHT><DIV CLASS=nbody>
      <INPUT TYPE=SUBMIT VALUE="Delete Group">
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>
</TABLE></CENTER></FORM><P>
EOF02

    &ryanFooter($ENV{'HTTP_REFERER'});
    exit;
  }
