#!/usr/bin/perl

  require './user-lib.pl';
  &ReadParse();
  @ulist = &list_users();
  %user = %{$ulist[$in{'num'}]};

#print "Content-type: text/html\n\n<PRE>\n\n";
#print "num = $in{'num'}\n\n";
#foreach (keys %user) { print "$_ = $user{$_}\n"; }
#exit;

  &error_setup($text{'udel_err'});
  %access = &get_module_acl("SystemManager");
  &can_edit_user(\%access, \%user) || &error($text{'udel_euser'});

  $| = 1;

  &header($text{'udel_title'}, "");


  if ($in{'confirmed'}) {
    # Check for repeat click
    if ($user{'user'} ne $in{'user'}) {
      print "<CENTER><TABLE BORDER=\"0\" WIDTH=\"620\">\n";
      print "<TR><TD>\n";
      print "<b>$text{'udel_ealready'}</b>. <p>\n";
      print "</TD></TR>\n";
      print "</TABLE></CENTER>\n\n";
      &ryanFooter("/SystemManager");
      exit;
    }

    ### Go ahead and do it!
    &other_modules("useradmin_delete_user", \%user);
	
    $ENV{'USERADMIN_USER'} = $user{'user'};
    $ENV{'USERADMIN_ACTION'} = 'DELETE_USER';
    &making_changes();
    &delete_user(\%user);

    foreach $g (&list_groups()) {
      @mems = split(/,/, $g->{'members'});
      $idx = &indexof($user{'user'}, @mems);

      if ($idx >= 0) {
        splice(@mems, $idx, 1);
        %newg = %$g;
        $newg{'members'} = join(',', @mems);
        &modify_group($g, \%newg);
      }

      $mygroup = $g if ($g->{'group'} eq $user{'user'});
    }

    if ($config{'new_user_group'} && $mygroup && !$mygroup->{'members'}) {
      local $another;

      foreach $ou (&list_users()) {
        $another++ if ($ou->{'gid'} == $mygroup->{'gid'});
      }

      if (!$another) {
        &delete_group($mygroup);
      }
    }

    &made_changes();

    if ($in{'delhome'} && $user{'home'} !~ /^\/+$/) {
      `rm -rf "$user{'home'}"`;
    }



    print <<EOF03;
<P><CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb> <TD><DIV CLASS=ttitle><B>Delete User</B></DIV></TD> </TR>

  <TR $cb> <TD>&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody>
      <B>This user was successfully deleted.
    </DIV></TD>
  </TR>

  <TR $cb> <TD>&nbsp;</TD> </TR>
</TABLE></CENTER><P>
EOF03

    &ryanFooter("");
    exit;
  }
  else {
    ### Check if something has changed.
    if ($user{'user'} ne $in{'user'}) {
      print "<CENTER><TABLE BORDER=\"0\" WIDTH=\"620\">\n";
      print "<TR><TD>\n";
      print "<b>$text{'udel_echanged'}</b> <p>\n";
      print "</TD></TR>\n";
      print "</TABLE></CENTER>\n\n";
      &ryanFooter("/SystemManager");
      exit;
    }

    ### Ask if the user is sure.
    $USER = $user{'user'};

    print <<EOF02;
<FORM ACTION="delete_user.cgi">
<INPUT TYPE=HIDDEN NAME=num VALUE="$in{'num'}">
<INPUT TYPE=HIDDEN NAME=user VALUE="$user{'user'}">
<INPUT TYPE=HIDDEN NAME=confirmed VALUE=1>
<P><CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb> <TD COLSPAN=2><DIV CLASS=ttitle><B>Delete User</B></DIV></TD> </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody>
      <B>Are you sure you want to delete the user '$USER'?
    </DIV></TD>
    <TD><DIV CLASS=nbody>
EOF02


    if ($user{'home'} ne "/") {
      ### `du -sk $user{'home'}` =~ /^([0-9]+)/; $size = $1;
      print "<input type=submit value=\"$text{'udel_del1'}\">\n";
      print "<input name=delhome type=submit value=\"$text{'udel_del2'}\">\n";
    }
    else {
      print "<input type=submit value=\"$text{'udel_del1'}\">\n";
    }


print <<EOF03;
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>
</TABLE></CENTER></FORM><P>
EOF03

    &ryanFooter($ENV{'HTTP_REFERER'});
    exit;
  }

