#!/usr/bin/perl

  require './user-lib.pl';
  &header($text{'index_title'}, "", "intro", 1, 1);
  $formno = 0;
  %access = &get_module_acl("SystemManager");

  ### List all local users
  @ulist = @allulist = &list_users();
  if ($access{'uedit_mode'} == 1) { @ulist = (); }
  elsif ($access{'uedit_mode'} == 2) {
    map { $canu{$_}++ } split(/\s+/, $access{'uedit'});
    @ulist = grep { $canu{$_->{'user'}} } @ulist;
  }
  elsif ($access{'uedit_mode'} == 3) {
    map { $cannotu{$_}++ } split(/\s+/, $access{'uedit'});
    @ulist = grep { !$cannotu{$_->{'user'}} } @ulist;
  }
  elsif ($access{'uedit_mode'} == 4) {
    @ulist = grep { (!$access{'uedit'} || $_->{'uid'} >= $access{'uedit'}) &&
                    (!$access{'uedit2'} || $_->{'uid'} <= $access{'uedit2'})
                  } @ulist;
  }
  elsif ($access{'uedit_mode'} == 5) {
    @ulist = grep { $_->{'gid'} == $access{'uedit'} } @ulist;
  }

  ### List all local groups
  @glist = @allglist = &list_groups();
  if ($access{'gedit_mode'} == 1) { @glist = (); }
  elsif ($access{'gedit_mode'} == 2) {
    map { $cang{$_}++ } split(/\s+/, $access{'gedit'});
    @glist = grep { $cang{$_->{'group'}} } @glist;
  }
  elsif ($access{'gedit_mode'} == 3) {
    map { $cannotg{$_}++ } split(/\s+/, $access{'gedit'});
    @glist = grep { !$cannotg{$_->{'group'}} } @glist;
  }
  elsif ($access{'gedit_mode'} == 4) {
    @glist = grep { (!$access{'gedit'} || $_->{'gid'} >= $access{'gedit'}) &&
                    (!$access{'gedit2'} || $_->{'gid'} <= $access{'gedit2'})
                  } @glist;
  }

  if (@glist) {
    if ($config{'sort_mode'}) {
      @glist = sort { $a->{'group'} cmp $b->{'group'} } @glist;
    }
    if ($config{'display_mode'}) {
      ### Display group name, ID and members.

      print <<EOF01;
<CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle>
    <B>Configure Secondary Groups</B>
  </DIV></TD></TR>

  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    Below you can configure secondary groups.  If you want a user to
    be part of another group in addition to their "primary" group, simply
    add them below.
  </DIV></TD></TR>

  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD>
      <TABLE BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=0>

      <tr $tb>
        <td><DIV CLASS="thead"><B>$text{'gedit_group'}</b></td>
        <td><DIV CLASS="thead"><B>$text{'gedit_members'}</b></td>
      </tr>

EOF01

### #######################################
### BEGIN RWM -- Only display if GID >= 100
### #######################################
      foreach $g (@glist) {
        if ($g->{'gid'} >= 100) {
          print "<tr $cb>\n";
          print "  <td><DIV CLASS=nbody><a href='edit_group.cgi?",
                "num=$g->{'num'}'>$g->{'group'}</a></td>\n";
          print "  <td><DIV CLASS=nbody>",&ifblank($g->{'members'}),"</td>\n";
          print "</tr>\n\n";
        }
      }
### #######################################
### BEGIN RWM -- Only display if GID >= 100
### #######################################

print <<EOF02;
      <TR><TD COLSPAN=2>&nbsp;</TD></TR>

      <TR><TD COLSPAN=2><DIV CLASS=nbody><B>
        <A HREF="edit_group.cgi">Create a New Group</A>
      </B></DIV></TD></TR>

      <TR><TD COLSPAN=2>&nbsp;</TD></TR>
      </TABLE>
    </TD>
  </TR>
</TABLE></CENTER><P>
EOF02

    }
  }

  &ryanFooter("/SystemManager/");


 
sub ifblank { return $_[0] ? $_[0] : "&nbsp;"; }

