#!/usr/bin/perl

  require 'webmin-lib.pl';
  &get_miniserv_config(\%miniserv);

  ### Print our header.
  &header("WebTool Access Control", "");

  print <<EOF01;
<FORM ACTION="do_access.cgi" METHOD=POST>
<CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
<TR $tb>
  <TD COLSPAN=2><DIV CLASS=ttitle><B>WebTool Access Control</B></DIV></TD>
</TR>

<TR $cb>
  <TD COLSPAN=2><DIV CLASS=nbody>
    The WebTool can be configured to deny or allow access only from certain
    IP addresses.  You control access based upon:

    <UL>
      <LI><B>Hostnames</B> (for example, mymachine.guardiandigital.com)
      <LI><B>IP Addresses</B> (for example, 192.168.10.80)
      <LI><B>IP Networks</B> (for example, 192.168.10.0)
    </UL>

   <P> You should limit access to trusted addresses, otherwise, anyone who
    guesses your password will have complete control of your system.  Enter
    one IP address or hostname on each line, then click on the <B>Save WebTool
     Access Control</B> button.

   <P>Your IP current IP address is <B>$ENV{'REMOTE_ADDR'}.</B>
  </DIV></TD>
</TR>

<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD VALIGN=TOP NOWRAP><DIV CLASS=nbody>
EOF01


  printf "<INPUT TYPE=RADIO NAME=access VALUE=0 %s>\n",
         $miniserv{"allow"} || $miniserv{"deny"} ? "" : "checked";
  print "$text{'access_all'}\n";

  printf "<BR><INPUT TYPE=RADIO NAME=access VALUE=1 %s>\n",
         $miniserv{"allow"} ? "checked" : "";
  print "$text{'access_allow'}\n";

  printf "<BR><INPUT TYPE=RADIO NAME=access VALUE=2 %s>\n",
         $miniserv{"deny"} ? "checked" : "";
  print "$text{'access_deny'}\n";

  print "  </TD>\n";
  print "  <TD VALIGN=TOP>\n";

  printf "    <TEXTAREA NAME=ip ROWS=6 COLS=30>%s</TEXTAREA>\n",
         $miniserv{"allow"} ? join("\n", split(/\s+/, $miniserv{"allow"})) :
         $miniserv{"deny"} ? join("\n", split(/\s+/, $miniserv{"deny"})) : "";

print <<EOF02;
  </TD>
</TR>

<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD COLSPAN=2 ALIGN=RIGHT><DIV CLASS=nbody>
    <INPUT TYPE=SUBMIT VALUE="Save WebTool Access Control">
  </DIV></TD>
</TR>
</TABLE></CENTER></FORM><P>
EOF02

  &ryanFooter("");

