#!/usr/bin/perl

  require './proc-lib.pl';
  use Config;
  &header($text{'edit_title'}, "", "edit_proc");
  %pinfo = &process_info($ARGV[0]);

  if (!%pinfo) {
    print "<CENTER><TABLE BORDER=\"0\" WIDTH=\"620\">\n";
    print "<TR><TD>\n";

    print "<b>$text{'edit_gone'}</b> <p>\n";
    print "</TD></TR>\n";
    print "</TABLE></CENTER>\n\n";

    &ryanFooter("", $text{'index_return'});
    exit;
  }

  $cut_str    = &cut_string($pinfo{args}, 60);
  $nice_hlink = &hlink("<b>$text{'nice'}</b>","nice");

  print <<EOF01;
<CENTER><table border=0 width=620 CELLPADDING=0 CELLSPACING=0>
<tr $tb>
  <td><DIV CLASS=thead><b>$text{'edit_title'}</b></td>
</tr>
<tr $cb>
  <td><table width=100%>
    <tr>
      <td width=20% nowrap><DIV CLASS=nbody><b>$text{'command'}</b></td>
      <td colspan=3><DIV CLASS=nbody><font size=+1>$cut_str</font></td>
    </tr>

    <tr>
      <td width=20% nowrap><DIV CLASS=nbody><b>$text{'pid'}</b></td>
      <td><DIV CLASS=nbody>$pinfo{pid}</td>
      <td width=20% nowrap><DIV CLASS=nbody><b>$text{'parent'}</b></td>
EOF01

  if ($pinfo{ppid}) {
    local %ppinfo = &process_info($pinfo{ppid});
    print "<td><DIV CLASS=nbody><a href=\"edit_proc.cgi?$ppinfo{pid}\">",
          &cut_string($ppinfo{'args'},30),"</a></td>";
  }
  else { print "<td><DIV CLASS=nbody>None</td>"; }

  print <<EOF02;
    </tr>

    <tr>
      <td width=20% nowrap><DIV CLASS=nbody><b>$text{'owner'}</b></td>
      <td><DIV CLASS=nbody>$pinfo{'user'}</td>
      <td width=20% nowrap><DIV CLASS=nbody><b>$text{'cpu'}</b></td>
      <td><DIV CLASS=nbody>$pinfo{'cpu'}</td>
    </tr>

    <tr>
      <td width=20% nowrap><DIV CLASS=nbody><b>$text{'size'}</b></td>
      <td><DIV CLASS=nbody>$pinfo{'size'}</td>
      <td width=20% nowrap><DIV CLASS=nbody><b>$text{'runtime'}</b></td>
      <td><DIV CLASS=nbody>$pinfo{'time'}</td>
    </tr>

EOF02
#    <tr>
#      <td><DIV CLASS=nbody>$nice_hlink</td>
#      <form action=renice_proc.cgi>
#      <input type=hidden name=pid value=$ARGV[0]>
#      <td colspan=3><DIV CLASS=nbody>

#  if (&indexof($pinfo{nice}, @nice_range) < 0) { print $pinfo{nice}; }
#  else {
#    print "<select name=nice>\n";
#
#    for($i=0; $i<@nice_range; $i++) {
#      printf "<option value=%d %s>%d%s\n",
#      $nice_range[$i],
#      $pinfo{nice} == $nice_range[$i] ? "selected" : "",
#      $nice_range[$i],
#      $i==0 ? " (High priority)" :
#      $i==@nice_range-1 ? " (Low priority)" :
#      $nice_range[$i]==0 ? " (Default)" : "";
#    }
#	print "</select> <input type=submit value='$text{'edit_change'}'>\n";
#  }

#  print "</td> </form></tr>\n";

  $i = 0;
  foreach $k (keys %pinfo) {
    if ($k =~ /^_/) {
      if ($i%2 == 0) { print "<tr>\n"; }
      printf "<td width=20%% nowrap><DIV CLASS=nbody><b>%s</b></td>\n",
      $info_arg_map{$k};
      print "<td><DIV CLASS=nbody>$pinfo{$k}</td>\n";
      if ($i%2 == 1) { print "<tr>\n"; }
      $i++;
    }
  }

print "</table></td></tr></table></CENTER><p>\n";

#print "<CENTER><TABLE BORDER=\"0\" WIDTH=\"620\">\n";
#print "<TR><TD><DIV CLASS=nbody>\n";

#print "<form action=kill_proc.cgi>\n";
#print "<input type=submit value=\"$text{'edit_kill'}\">\n";
#print "<input type=hidden name=pid value=$pinfo{pid}>\n";
#print "<select name=signal>\n";
#foreach $s (split(/\s+/, $Config{sig_name})) {
#	printf "<option value=\"$s\" %s> $s\n",
#		$s eq "TERM" ? "selected" : "";
#	}
#print "</select></form>\n";
#print "</TD></TR>\n";
#print "</TABLE></CENTER>\n\n";



  @sub = grep { $_->{'ppid'} == $pinfo{pid} } &list_processes();
  if (@sub) {
    print "<CENTER><table border=0 width=620 cellpadding=0 CELLSPACING=0>\n";
    print "<tr $tb>\n";
    print "  <td><DIV CLASS=\"thead\"><b>$text{'edit_sub'}</b></td>\n";
    print "</tr>\n";

    print "<tr $cb>\n";
    print "  <td><table WIDTH=100%>\n";

    @sub = sort { $a->{'pid'} <=> $b->{'pid'} } @sub;

    foreach $s (@sub) {
      local $p = $s->{'pid'};
      print "<tr>\n";
      print "  <td><DIV CLASS=nbody><a href=\"edit_proc.cgi?$p\">$p</a></td>\n";
      print "  <td><DIV CLASS=nbody>",&cut_string($s->{args}, 80),"...</td>\n";
      print "</tr>\n";
    }

    print "</table></td></tr></table></CENTER><p>\n";
  }

  &ryanFooter("index_user.cgi");

