#!/usr/bin/perl

  ### Startup Stuff
  require './StatusMonitor.pl';
  &init_config();

  $df      = `/bin/df -h`;
  $netstat = `/bin/netstat --inet -p`;
  $uname   = `/bin/uname -a`;
  $uptime  = `/usr/bin/uptime`;

  &header("System Statistics", 0, 0);

print <<EOF;
<BR><CENTER><TABLE BORDER="0" WIDTH="620" CELLSPACING="0" CELLPADDING="0">
  <TR $tb><TD>
    <DIV CLASS=ttitle><B>System Statistics</B></DIV>
  </TD></TR>

  <TR $cb><TD>&nbsp;</TD></TR>

  <TR>
    <TD $tb><DIV CLASS="thead"><B>System Information</B> </TD>
  </TR>
  <TR><TD $cb><DIV CLASS=nbody>$uname</TD></TR>
  <TR><TD $cb><DIV CLASS=nbody>$uptime</TD></TR>

  <TR><TD $cb>&nbsp;</TD></TR>

  </TABLE></CENTER>

  <BR><BR><CENTER><TABLE BORDER="0" WIDTH="620" CELLSPACING=0 CELLPADDING=0>
  <TR>
    <TD $tb COLSPAN=6><DIV CLASS="thead"><B>Disk Usage</B> </TD>
  </TR>
  <TR>
    <TD $cb><DIV CLASS=nbody><B>Filesystem</TD>
    <TD $cb><DIV CLASS=nbody><B>1k-blocks</TD>
    <TD $cb><DIV CLASS=nbody><B>Used</TD>
    <TD $cb><DIV CLASS=nbody><B>Available</TD>
    <TD $cb><DIV CLASS=nbody><B>Use%</TD>
    <TD $cb><DIV CLASS=nbody><B>Mounted on</TD>
  </TR>

EOF

  @df_lines = split /\n/, $df;

  foreach $df_line (@df_lines) {
    if ($df_line !~ m/^[^\/]/) {
      @df_items = split /[\ \t]+/, $df_line;
      $COLOR = 'BLACK';

      ### Orange if over 70%, Red if over 90%.
      if ($df_items[4] =~ m/[789][0-9]\%/) { $COLOR = 'ORANGE'; }
      if ($df_items[4] =~ m/[9][0-9]\%/) { $COLOR = 'RED'; }

      print "  <TR>\n";
      print "  <TD $cb><DIV CLASS=nbody><FONT COLOR=$COLOR>$df_items[0]</TD>\n";
      print "  <TD $cb><DIV CLASS=nbody><FONT COLOR=$COLOR>$df_items[1]</TD>\n";
      print "  <TD $cb><DIV CLASS=nbody><FONT COLOR=$COLOR>$df_items[2]</TD>\n";
      print "  <TD $cb><DIV CLASS=nbody><FONT COLOR=$COLOR>$df_items[3]</TD>\n";
      print "  <TD $cb><DIV CLASS=nbody><FONT COLOR=$COLOR>$df_items[4]</TD>\n";
      print "  <TD $cb><DIV CLASS=nbody><FONT COLOR=$COLOR>$df_items[5]</TD>\n";
      print "  </TR>\n\n";
    }
  }

print <<EOF2;
    <TR><TD $cb COLSPAN="6">&nbsp;</TD></TR>
  </TABLE></CENTER><BR>


  <!-- netstat -->
  <BR><CENTER><TABLE BORDER="0" WIDTH="620" CELLSPACING=0 CELLPADDING=0>
  <TR>
    <TD $tb COLSPAN=5><DIV CLASS="thead"><B>Active Network Connections</B></TD>
  </TR>
  <TR>
    <TD $cb><DIV CLASS=nbody><B>Protocol</B></TD>
    <TD $cb><DIV CLASS=nbody><B>Local Address:Port</B></TD>
    <TD $cb><DIV CLASS=nbody><B>Foreign Address:Port</B></TD>
    <TD $cb><DIV CLASS=nbody><B>State</B></TD>
    <TD $cb><DIV CLASS=nbody><B>Program</B></TD>
  </TR>

EOF2

  @netstat_lines = split /\n/, $netstat;

  foreach $netstat_line (@netstat_lines) {
    if ($netstat_line !~ m/^[A-Z]/) {
      @netstat_items = split /[\ \t]+/, $netstat_line;

      ($pid, $processname)  =  split /\//, $netstat_items[6];

      print "  <TR>\n";
      print "    <TD $cb><DIV CLASS=nbody><FONT COLOR=$COLOR>$netstat_items[0]</TD>\n";
      print "    <TD $cb><DIV CLASS=nbody><FONT COLOR=$COLOR>$netstat_items[3]</TD>\n";
      print "    <TD $cb><DIV CLASS=nbody><FONT COLOR=$COLOR>$netstat_items[4]</TD>\n";
      print "    <TD $cb><DIV CLASS=nbody><FONT COLOR=$COLOR>$netstat_items[5]</TD>\n";
      print "    <TD $cb><DIV CLASS=nbody><FONT COLOR=$COLOR>$processname</TD>\n";
      print "  </TR>\n\n";
    }
  }

  print "<TR><TD $cb COLSPAN=\"5\">&nbsp;</TD></TR>\n";
  print "</TABLE></CENTER><BR>\n";

  &ryanFooter(" ");
