#!/usr/bin/perl

  ### Do startup stuff.
  require "./gdbackup-lib.pl";
  &ReadParse();

  $name = $in{'name'};
  $tmp = `egrep $name lang/en`;
  ($code) = ($tmp =~ m/([a-z]+[0-9]+)\_.*/);

  $str = $code . "_file";
  $handle = $text{$str};
  $cron_daily  = "/etc/cron.daily/$handle";
  $cron_weekly = "/etc/cron.weekly/$handle";

  if ($tmp =~ m/^backup/) {
    &PrintError("This is a built-in named backup.  Deletion is not allowed");
    exit;
  }



  ### Declare some variables.
  my (%fileBackups, @myBackups, $backupFile);
  $backupFile = "lang/en";


  ### Lock and open the output file.
  &obtain_lock($backupFile);
  open(BACKUPFILE, "$backupFile");
    while (<BACKUPFILE>) { push @bfile, $_; }
  close(BACKUPFILE);
  &release_lock($backupFile);


  &obtain_lock($backupFile);
  open(BACKUPFILE, ">$backupFile");
    foreach $line (@bfile) {
      if ($line !~ m/^$code/) { print BACKUPFILE "$line"; }
    }
  close(BACKUPFILE);
  &release_lock($backupFile);


  ### Delete cron jobs, if any.
  unlink $cron_daily;
  unlink $cron_weekly;


  ### I'm... sailing... away...
  &redirect("");
