#!/usr/bin/perl

  ### Bow down before the one you serve.
  require "./gdbackup-lib.pl";

  ### If /var/BACKUP does not exist, then create it.
  if (!-r "/var/BACKUP") { mkdir "/var/BACKUP", 0700; }

  ### Do the header thing.
  &header($text{'module_title'}, "");


print <<EOF01;
  <P><CENTER><TABLE WIDTH="620" BORDER=0 CELLPADDING=0 CELLSPACING=0>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>System Backup</B></DIV></TD></TR>
  <TR $cb>
    <TD COLSPAN=2><DIV CLASS=nbody>
      By using the selections below you can perform various functions to
      backups such as create, delete, or view.</DIV>
    </TD>
  </TR>

  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="thead"><B>Backup Maintenance</B></TD>
  </TR>

  <TR $cb>
    <TD VALIGN="TOP">
      <B><DIV CLASS=nbody>Please select a function:</B>
    </TD>
    <TD ALIGN="CENTER"><DIV CLASS=nbody>
      <FORM ACTION="displayScreen.cgi" METHOD="POST">
      <SELECT NAME="FUNCTION">
        <OPTION VALUE="New Backup">Create a new backup</OPTION>
        <OPTION VALUE="Restore Backup">Restore a backup</OPTION>
        <OPTION VALUE="Delete Backup">Delete an existing backup</OPTION>
        <OPTION VALUE="View Backup">View the contents of a backup</OPTION>
        <OPTION VALUE="View Changed">See which files have been changed since backup</OPTION>
      </SELECT>
  </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" VALUE="Execute"><P></FORM>
    </TD>
  </TR>
  

  </TABLE></CENTER>
  <P><CENTER><TABLE WIDTH="620" BORDER=0 CELLPADDING=0 CELLSPACING=0>

  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="thead"><B>Schedule a Named Backup</B></TD>
  </TR>
  <TR $cb><TD COLSPAN="2"><DIV CLASS=nbody>This menu will allow you to schedule a backup either every night or every week.</TD></TR>

  <TR $cb><TD COLSPAN="2">&nbsp;</TD></TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B>Name of Backup</B></TD>
    <TD><DIV CLASS=nbody><B>When to Backup?</B></TD>
  </TR>

  <TR $cb>
    <FORM ACTION="managedBackup.cgi" METHOD="POST">
    <INPUT TYPE="HIDDEN" NAME="TYPE" VALUE="SCHEDULE">
    <TD ALIGN="CENTER"><DIV CLASS=nbody>
      <SELECT NAME="name">
EOF01

  foreach $x (&listBackups('desc')) {
    print "          <OPTION VALUE=\"$x->{'code'}\">$x->{'name'}</OPTION>\n";
  }

print <<EOF03;
        </SELECT>
      </TD>
      <TD><DIV CLASS=nbody>
        <SELECT NAME="when">
          <OPTION VALUE="nightly">Nightly</OPTION>
          <OPTION VALUE="weekly">Weekly</OPTION>
        </SELECT>
      </TD>
    </TR>

    <TR $cb>
      <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS=nbody>
        <INPUT TYPE="SUBMIT" VALUE="Schedule"><P></FORM>
      </TD>
    </TR>

    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

    <TR $cb>
      <TD ALIGN="LEFT"><DIV CLASS=nbody>
        <A HREF="named_backup.cgi?fcn=new"><B>New Named Backup</B></A>
      </TD>
      <TD ALIGN="RIGHT">
        <A HREF="named_backup.cgi?fcn=del"><B>Delete Named Backup</B></A>
      </TD>
    </TR>

    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

  </TABLE></CENTER>



  <P><CENTER><TABLE WIDTH="620" CELLPADDING=0 CELLSPACING=0 BORDER="0">
    <TR $tb>
      <TD COLSPAN="2"><DIV CLASS="thead"><B>Currently Scheduled Backups</B></TD>
    </TR>
  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    This table displays all scheduled backups that exist, if any.  To delete a
    backup, simply click on it.
  </TD></TR>

  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

EOF03


  ### Get backups list.

  print "<TR $cb>\n";
  print "  <TD><DIV CLASS=nbody><B>Name of Backup</B></TD>\n";
  print "  <TD><DIV CLASS=nbody><B>When to Backup</B></TD>\n";
  print "</TR>\n";

  ### List daily backups.
  foreach $d (&listSavedBackups('daily')) {
    $tmp = codeToText($d);
    print "<TR $cb>\n";
    print "  <TD><DIV CLASS=nbody><A HREF=\"del_cron.cgi?code=$d&freq=daily\">$tmp</A></TD>\n";
    print "  <TD><DIV CLASS=nbody>Nightly</TD>\n";
    print "</TR>\n";
  }

  ### List Weekly backups.
  foreach $w (&listSavedBackups('weekly')) {
    $tmp = codeToText($w);
    print "<TR $cb>\n";
    print "  <TD><DIV CLASS=nbody><A HREF=\"del_cron.cgi?code=$w&freq=weekly\">$tmp</A></TD>\n";
    print "  <TD><DIV CLASS=nbody>Weekly</TD>\n";
    print "</TR>\n";
  }

  print "<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>\n\n";

  print "</TABLE></CENTER><BR><BR>\n";
  &ryanFooter("/");
