#!/usr/bin/perl

  require './bind8-lib.pl';
  &ReadParse();

  $conf = &get_config();
  $zconf = $conf->[$in{'index'}]->{'members'};
  $dom = $conf->[$in{'index'}]->{'value'};

  %access = &get_module_acl();
  &can_edit_zone(\%access, $dom) || &error($text{'master_ecannot'});

  &header($text{'master_title'}, "");
  $arpa_str = &arpa_to_ip($dom);


print <<EOF01;
<P><CENTER><TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=620>
<TR $tb>
  <TD COLSPAN=2><DIV CLASS=ttitle><B>DNS Management</B></DIV></TD>
</TR>

<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD WIDTH=20>&nbsp;</TD>
  <TD ALIGN=RIGHT>
    <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>

    <TR $tb>
      <TD COLSPAN=2><DIV CLASS=ttitle><B>$text{'master_opts'}</B></td>
    </TR>

    <TR $tb>
      <TD COLSPAN=2><DIV CLASS=thead><B>$arpa_str</B>
    </TR>

    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

EOF01

  @recs = &read_zone_file(&find("file", $zconf)->{'value'}, $dom);

  if ($dom =~ /in-addr.arpa/i) { @rcodes = ("PTR", "NS"); }
  else { @rcodes = ("A", "NS", "CNAME", "MX"); }

  foreach $c (@rcodes) { $rnum{$c} = 0; }

  foreach $r (@recs) {
    $rnum{$r->{'type'}}++;
    if ($r->{'type'} eq "SOA") { $soa = $r; }
  }

  ### Display as list.
  $mid = int((@rcodes+1)/2);

  print "<tr>\n";
  print "  <td width=50%>\n";
    &types_table(@rcodes[0..$mid-1]);
  print "  </td>\n";
  print "  <td width=50%>\n";
    &types_table(@rcodes[$mid..$#rcodes]);
  print "  </td>\n";
  print "</tr>\n";

print <<EOF02;

    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>


    <TR $cb>
      <TD ALIGN=CENTER><B>
        <A HREF="edit_soa.cgi?index=$in{'index'}">$text{'master_soa'}</A>
      </TD>
      <TD ALIGN=CENTER><B>
        <A HREF="edit_options.cgi?index=$in{'index'}">$text{'master_options'}</A>
      </TD>
    </TR>

    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>


    <TR $cb><TD COLSPAN=2>
      <TABLE>
      <TR>
        <TD>
          <DIV CLASS=nbody>
          <form action=delete_zone.cgi>
          <input type=hidden name=index value="$in{'index'}">
          <input type=submit value="$text{'master_del'}">
        </TD>
        <TD><DIV CLASS=nbody> $text{'master_delmsg'}
EOF02
  if ($dom !~ /in-addr.arpa/i) { print "$text{'master_delrev'}\n"; }
print <<EOF03;
        </TD>
      </TR>
      </TABLE>

      </TD>
    </TR>
    </TABLE>

  </TD>
</TR>
</TABLE>

</form>
EOF03

  &ryanFooter("");










sub types_table {
  if ($_[0]) {
    local($i);

    print "<table border=0 width=100% CELLPADDING=0 CELLSPACING=0>\n";
    print "<tr $tb> <td><DIV CLASS=thead><b>$text{'master_type'}</b></td> ",
          "<td><DIV CLASS=thead><b>$text{'master_records'}</b></td> </tr>\n";

    for($i=0; $_[$i]; $i++) {
      print "<tr $cb> <td><DIV CLASS=nbody><a href=\"edit_recs.cgi?",
            "index=$in{'index'}&type=$_[$i]\">",$text{"type_$_[$i]"},
            "</a></td>\n";
      print "<td><DIV CLASS=nbody>$rnum{$_[$i]}</td> </tr>\n";
    }

    print "</table>\n";
  }
}

