#!/usr/bin/perl

  ### Startup Stuff
  require 'SystemManager.pl';
  require 'useradmin/user-lib.pl';
  &init_config();

  &header("System Manager", 0);
  $formno = 0;
  %access = &get_module_acl("useradmin");

  @ulist = @allulist = &list_users();

  if ($access{'uedit_mode'} == 1) { @ulist = (); }
  elsif ($access{'uedit_mode'} == 2) {
    map { $canu{$_}++ } split(/\s+/, $access{'uedit'});
    @ulist = grep { $canu{$_->{'user'}} } @ulist;
  }
  elsif ($access{'uedit_mode'} == 3) {
    map { $cannotu{$_}++ } split(/\s+/, $access{'uedit'});
    @ulist = grep { !$cannotu{$_->{'user'}} } @ulist;
  }
  elsif ($access{'uedit_mode'} == 4) {
    @ulist = grep {
      (!$access{'uedit'} || $_->{'uid'} >= $access{'uedit'}) &&
      (!$access{'uedit2'} || $_->{'uid'} <= $access{'uedit2'})
    } @ulist;
  }
  elsif ($access{'uedit_mode'} == 5) {
    @ulist = grep { $_->{'gid'} == $access{'uedit'} } @ulist;
  }

  if (@ulist > $config{'display_max'}) {
    ### Display user search form
    $formno++;
    print <<EOF2MANY;
<CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
<TR $tb> <TD><DIV CLASS=ttitle><B>Local User Management</B></DIV></TD> </TR>

<TR $cb> <TD><DIV CLASS=nbody>$text{'index_toomany'}</DIV></TD> </TR>

<TR $cb> <TD>&nbsp;</TD></TR>

<TR $cb>
  <TD><DIV CLASS=nbody>
    <FORM ACTION="useradmin/search_user.cgi" METHOD="POST">
    <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
    <TR>

      <TD><DIV CLASS=nbody><B>$text{'index_find'}</B></DIV></TD>

      <TD><DIV CLASS=nbody><SELECT NAME=field>
        <OPTION VALUE=user checked>$text{'user'}
        <OPTION VALUE=real>$text{'real'}
        <OPTION VALUE=shell>$text{'shell'}
        <OPTION VALUE=home>$text{'home'}
        <OPTION VALUE=uid>$text{'uid'}
      </SELECT></TD>
    
      <TD><DIV CLASS=nbody><SELECT NAME=match>
        <OPTION VALUE=0 checked>$text{'index_equals'}
        <OPTION VALUE=1>$text{'index_matches'}
        <OPTION VALUE=2>$text{'index_nequals'}
        <OPTION VALUE=3>$text{'index_nmatches'}
      </SELECT></TD>

      <TD><INPUT NAME=what SIZE=15></TD>

      <TD><DIV CLASS=nbody><INPUT TYPE=SUBMIT VALUE="$text{'find'}"></TD>

    </TR>

    <TR>
      <TD COLSPAN=5><DIV CLASS=nbody><B><A HREF="useradmin/search_user.cgi?field=user&match=1&what=.">[ View All Users ]</A></B></DIV></TD>
    </TR>

    </TABLE>
    <P></FORM>
  </TD>
</TR>
<TR $cb> <TD>&nbsp;</TD></TR>
</TABLE></CENTER>
EOF2MANY
    }

  elsif (@ulist) {
    # Display a table of all users
    if ($config{'sort_mode'} == 1) {
      @ulist = sort { $a->{'user'} cmp $b->{'user'} } @ulist;
    }
    elsif ($config{'sort_mode'} == 2) {
      @ulist = sort { lc($a->{'real'}) cmp lc($b->{'real'}) } @ulist;
    }
    elsif ($config{'sort_mode'} == 3) {
      @ulist = sort { @wa = split(/\s+/, $a->{'real'});
      @wb = split(/\s+/, $b->{'real'});
      lc($wa[@wa-1]) cmp lc($wb[@wb-1]) } @ulist;
    }
    elsif ($config{'sort_mode'} == 4) {
      @ulist = sort { $a->{'shell'} cmp $b->{'shell'} } @ulist;
    }

    print "<P><CENTER><table width=620 BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
    print "<TR $tb>\n";
    print "  <TD COLSPAN=5><DIV CLASS=ttitle><B>Local User Management</B></DIV></TD>\n";
    print "</TR>\n\n";

    print "<TR $cb>\n";
    print "  <TD COLSPAN=5><DIV CLASS=nbody>Below you can find a listing of all the users who currently have access to your machine.  Next to their name is their user ID, their \"Real name\", their home directory on the machine, and their \"shell.\"  If their shell is /bin/false then they do not have remote access privleges.  <P>Click on a username to edit any of these parameters, or click on \"Create New User\" to add a user to your system.  <P>Each user is also a member of a \"group.\"  You can add/delete/edit groups by clicking on the \"Configure Groups\" button.</DIV></TD>\n";
    print "</TR>\n";

    print "<TR $cb> <TD COLSPAN=5>&nbsp;</DIV></TD> </TR>\n";

    print "<tr $tb> <td><DIV CLASS=\"thead\"><b>$text{'user'}</b></td> ",
          "         <td><DIV CLASS=\"thead\"><b>$text{'uid'}</b></td> ",
          "         <td><DIV CLASS=\"thead\"><b>$text{'real'}</b></td> ",
          "         <td><DIV CLASS=\"thead\"><b>$text{'home'}</b></td> ",
          "         <td><DIV CLASS=\"thead\"><b>$text{'shell'}</b></td>\n",
          "</tr>\n";


    ### Only display if UID >= 500
    foreach $u (@ulist) {
      if ($u->{'uid'} >= 500) {
        print "<tr $cb>\n";
        print "  <td><DIV CLASS=\"nbody\"><a href='useradmin/edit_user.cgi?num=$u->{'num'}'>$u->{'user'}</a></td>\n";
        print "  <td><DIV CLASS=\"nbody\">$u->{'uid'}</td>\n";
        print "  <td><DIV CLASS=\"nbody\">", &ifblank($u->{'real'}),"</td>\n";
        print "  <td><DIV CLASS=\"nbody\">", &ifblank($u->{'home'}),"</td>\n";
        print "  <td><DIV CLASS=\"nbody\">", &ifblank($u->{'shell'}),"</td>\n";
        print "</tr>\n";
      }
    }

    print "<TR $cb><TD COLSPAN=5>&nbsp;</TD></TR>\n";

    print "<TR $cb>\n";
    print "  <TD ALIGN=LEFT COLSPAN=2>\n";
    print "    <FORM ACTION=\"useradmin/edit_user.cgi\" METHOD=\"POST\">\n";
    print "      <DIV CLASS=nbody>\n";
    print "      <INPUT TYPE=SUBMIT VALUE=\"Create New User\">\n";
    print "    <P></FORM>\n";
    print "  </TD>\n";

    print "  <TD WIDTH=100% COLSPAN=2>&nbsp;</TD>\n";

    print "  <TD ALIGN=RIGHT COLSPAN=1>\n";
    print "    <FORM ACTION=\"useradmin/list_groups.cgi\" METHOD=\"POST\">\n";
    print "      <DIV CLASS=nbody>\n";
    print "      <INPUT TYPE=SUBMIT VALUE=\"Configure Groups\">\n";
    print "    <P></FORM>\n";
    print "  </TD>\n";
    print "</TR>\n";

    print "</table></CENTER>\n";
  }



print <<EOF10;

  <BR><BR>
  <CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING="0" CELLSPACING=0>
  <TR $tb>
      <TD COLSPAN=2><DIV CLASS=ttitle><B>System Management</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN=2><DIV CLASS="nbody">
      Below you can perform vaious system maintenance functions.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B><A HREF="net/">Network Configuration</B></DIV></TD>
    <TD><DIV CLASS=nbody>Basic network configuration.</TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B><A HREF="time/">System Time</B></DIV></TD>
    <TD><DIV CLASS=nbody>
      Change system time and configure remote time servers.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B><A HREF="sshd/">Secure Shell Management</B></TD>
    <TD><DIV CLASS=nbody>Configure your ssh server or generate user keys.</TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B><A HREF="postfix/">Mail Server Management</B></TD>
    <TD><DIV CLASS=nbody>Configure your mail server.</TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B><A HREF="bind/">DNS Management</B></DIV></TD>
    <TD><DIV CLASS=nbody>Configure your DNS server.</TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

EOF10

  if (! system "rpm -q WebTool-proxy > /dev/null 2>&1") {
    print "  <TR $cb>\n";
    print "    <TD><DIV CLASS=nbody><B><A HREF=\"proxy/\">Proxy Management</B>";
    print "</DIV></TD>\n";
    print "    <TD><DIV CLASS=nbody>Configure your proxy users and define ";
    print "access control lists.</TD>\n";
    print "  </TR>\n\n";
    print "  <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>\n\n";
  }

  print "  </TABLE></CENTER><BR>\n\n";
  &ryanFooter("/");











sub ifblank {
  return $_[0] ? $_[0] : "&nbsp;";
}

