#!/usr/bin/perl

  require './postfix-lib.pl';

  &header("Mail Server Management: Domain Management", "");

  print <<EOF01;
<P><CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING="0" CELLSPACING="0">
  <TR $tb>
    <TD COLSPAN="5"><DIV CLASS="ttitle"><B>Mail Server Management</B></TD>
  </TR>

  <TR $cb> <TD COLSPAN="5">&nbsp;</TD> </TR>

  <TR $tb>
    <TD COLSPAN="5"><DIV CLASS="thead"><B>Domain Management</B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="5"><DIV CLASS="nbody">
      Please click on a domain to configure it.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="5">&nbsp;</TD> </TR>
  <TR $cb>
    <TD COLSPAN="5">
      <TABLE>
      <TR>
EOF01

  @domains = &get_domains();

  $i = 1;
  foreach $domain (@domains) {
    if (($i++ % 6) == 0) {
      print "</TR>\n";
      print "<TR $cb>\n";
      print "  <TD><DIV CLASS=\"nbody\">\n";
      print "    <A HREF=\"edit_domain.cgi?domain=$domain\">$domain</A>\n";
      print "  </DIV></TD>\n";
    }
    else {
      print "  <TD><DIV CLASS=\"nbody\">\n";
      print "    <A HREF=\"edit_domain.cgi?domain=$domain\">$domain</A>\n";
      print "  </DIV></TD>\n";
    }
  }

  $postmaster = &hlink("Postmaster", "postmaster");

print <<EOF02;
    </TR>
    </TABLE>
  </TD>
</TR>

  <TR $cb> <TD COLSPAN="5">&nbsp;</TD> </TR>

  <TR $tb>
    <TD COLSPAN="5"><DIV CLASS="thead"><B>Create New Domain</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="5"><DIV CLASS="nbody">
      Below you can add a domain you wish to recieve mail for.
  
      <P>The <B>$postmaster</B> is the the person who recieves all 
      undeliverable mail.  Some example values are:  "rwm", "dave", or 
      "ryan\@guardiandigital.com".
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="5">&nbsp;</TD> </TR>

  <TR $cb>
    <TD COLSPAN=5>
    <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>

      <TR>
        <TD WIDTH=20>&nbsp;</TD>
        <TD $tb><DIV CLASS="thead"><B>Domain</B></DIV></TD>
        <TD COLSPAN="2" $tb><DIV CLASS="thead"><B>Postmaster</B></DIV></TD>
      </TR>

      <TR $cb>
        <TD WIDTH=20>&nbsp;</TD>
        <TD>
          <FORM ACTION="add_domain.cgi" METHOD="POST">
          <DIV CLASS=tbody><INPUT TYPE=TEXT NAME=domain SIZE=20></DIV>
        </TD>
        <TD>
          <DIV CLASS=tbody><INPUT TYPE="TEXT" NAME="defrec" SIZE="15"></DIV>
        </TD>
        <TD>
          <DIV CLASS=nbody><INPUT TYPE=SUBMIT VALUE="Add New Domain"></DIV>
          <P></FORM>
        </TD>
      </TR>

    </TABLE>
    </TD>
  </TR>
</TABLE><P>
EOF02

  ### Go back to main page.
  &ryanFooter("");
