#!/usr/bin/perl

  ### Obligitory includes.
  require './postfix-lib.pl';
  &ReadParse();

  ### ################# ###
  ### Delete a mapping. ###
  ### ################# ###
  if ($in{'delete'}) {

    ### Delete the entry from the transport map.
    $lref = &read_file_lines("/etc/postfix/transport");

    ### Find the '### $ ... $' line number.
    for ($i = 0; $i < @$lref; $i++) {
      if (@$lref[$i] =~ m/^\#\#\#\ \$\ $in{'name'}\ $in{'value'}\ \$$/) {
        $START = $i;
      }
    }

    ### Splice out four lines, starting with $START.
    splice @$lref, $START, 4;
    &flush_file_lines();

    ### Delete the domain from $relay_domains.
    &delete_relaydomain($in{'name'});
  }


  ### ########################### ###
  ### Update an existing mapping. ###
  ### ########################### ###
  elsif ($in{'save'}) {

    ### This is the line number of the '### $ ... $' entry.
    $START = $in{'number'};

    ### Modify the transport map entry.
    $lref = &read_file_lines("/etc/postfix/transport");
      splice @$lref, $START,     1, "### \$ $in{'name'} $in{'value'} \$";
      splice @$lref, $START + 1, 1, "$in{'name'}\tsmtp:$in{'value'}";
      splice @$lref, $START + 2, 1, ".$in{'name'}\tsmtp:$in{'value'}";
    &flush_file_lines();

    ### Update $relay_domains with the new domain name.
    if ($in{'olddomain'} ne $in{'name'}) {
      &modify_relaydomain($in{'olddomain'}, $in{'name'});
    }
  }


  ### ################## ###
  ### Add a new mapping. ###
  ### ################## ###
  elsif ($in{'save_new'}) {

    ### Add an entry to the transport map.
    $lref = &read_file_lines("/etc/postfix/transport");
      push @$lref, "### \$ $in{'name'} $in{'value'} \$";
      push @$lref, "$in{'name'}\tsmtp:$in{'value'}";
      push @$lref, ".$in{'name'}\tsmtp:$in{'value'}\n";
    &flush_file_lines();

    ### Add the domain to $relay_domains.
    &add_relaydomain($in{'name'});
  }



  ### Rehash the table and reload the daemon.
  &regenerate_transport_table();
  &reload_postfix();

  ### Go back to the main page.
  &redirect("relay_hosts.cgi");
